New to KendoReact? Start a free 30-day trial

Tools
Premium

Updated on Aug 14, 2026

The React Editor, part of KendoReact, provides a set of built-in, user-interface tools, enables you to customize the available tools and to add custom ones.

Using Built-In Tools

To add or remove any of the available tools, use the tools prop of the Editor. All tools which are inserted in an array are rendered in a KendoReact ButtonGroup component.

The following example demonstrates all available tools of the React Editor, part of KendoReact.

Example
View Source
Loading ...

Customizing Built-In Tools

To customize any of the built-in tools of the Editor:

  1. Based on the default tool configuration, create the desired tool settings.
  2. Pass the settings to the corresponding function which creates the tool.

In the following example, the built-in Bold tool is changed to toggle the B tag, recognize the STRONG tag, its tooltip is changed to My Custom Bold, and the icon is reused. The FontSize DropDownList width and items are changed.

Example
View Source
Loading ...

The following code snippet demonstrates all tool settings and their corresponding functions which create the tools.

jsx
  import { EditorToolsSettings, EditorTools } from '@progress/kendo-react-editor';

  const {
  bold, italic, underline, strikethrough, subscript, superscript,
  alignLeft, alignCenter, alignRight, alignJustify,
  indent, outdent,
  orderedList, bulletList,
  undo,
  redo,
  fontSize, fontName,
  formatBlock,
  link,
  unlink,
  image,
  viewHtml,
  insertTable,
  addRowBefore,
  addRowAfter,
  addColumnBefore,
  addColumnAfter,
  deleteRow,
  deleteColumn,
  deleteTable,
  mergeCells,
  splitCell
  } = EditorToolsSettings;

  const {
  createAlignTool,
  createStyleDropDownList, // Accepts fontSize and fontName settings.
  createFormatBlockDropDownList, // The formatBlock settings.
  createUndoTool,
  createRedoTool,
  createIndentTool,
  createOutdentTool,
  createInlineFormatTool, // bold, italic, underline, strikethrough, subscript, superscript
  createInsertImageTool, // image
  createLinkTool,
  createUnlinkTool,
  createListTool, // orderedList, bulletList
  createViewHtmlToo
  // Inserting and editing tables.
  createInsertTableTool,
  createAddRowBeforeTool,
  createAddRowAfterTool,
  createAddColumnBeforeTool,
  createAddColumnAfterTool,
  createDeleteRowTool,
  createDeleteColumnTool,
  createDeleteTableTool,
  createMergeCellsTool,
  createSplitCellTool
  } = EditorTools;

To customize the ColorPicker of ForeColor or BackColor tools, wrap the tool into a function and pass the new props to colorPickerProps.

jsx
  import { Editor, EditorTools } from '@progress/kendo-react-editor';

  const { ForeColor, BackColor, Bold, Italic, Underline } = EditorTools;

  const CustomForeColor = props => (
    <ForeColor {...props} colorPickerProps={{ view: 'gradient' }} />
  );
  const CustomBackColor = props => (
    <BackColor {...props} colorPickerProps={{ view: 'gradient' }} />
  );

  const App = () => {
    return (
      <Editor
        tools={[[Bold, Italic, Underline], CustomForeColor, CustomBackColor]}
        contentStyle={{ height: 300 }}
        defaultContent={'<p>Editor Content</p>'}
      />
    );
  };

Using Custom Tools

The React Editor, part of KendoReact, allows you to create and implement custom tools.

The following example demonstrates how to create:

  • A drop-down list for applying color styles.
  • A tool for toggling the background color style.
  • Tools for inserting specific elements into the content.
Example
View Source
Loading ...

Creating Custom Tools Using CSS and Plugins

The KendoReact Editor allows you to use plugins and CSS styles in custom tools.

The following example demonstrates how to implement a custom paragraph marker tool by:

  • Using custom styles.
  • Utilizing the Decoration plugin.
  • Passing data from the tool to the plugin.
Example
View Source
Loading ...

New to Kendo UI for AngularStart a free 30-day trial

Toolbar Tools

Updated on Aug 14, 2026

The Angular Editor provides user interface tools and directives for associating these tools with edit-action commands through the Kendo UI for Angular ToolBarComponent.

By default, the Editor supports a default toolbar configuration which includes basic formatting controls and list options.

To add, remove, or regroup the default tools:

  1. Nest the kendo-toolbar tag inside the kendo-editor tag.
  2. Either include specific built-in tools or create and implement custom tools.

Built-In Tools

Out of the box, the Editor provides text formatting, list, images and link management options.

Example
View Source
Loading ...

Available Control Types

Depending on their visual implementation, the built-in tools are grouped in toolbar control types. The Kendo UI for Angular Editor provides the following control types:

Each control type supports a set of commands. For a list of all Editor commands, refer to the Editor API.

The following tables list the directives and components with their associated commands by control type.

Buttons

The built-in tools are implemented through specific directives and components, which automatically sets the icon of the button, click action, and the selected or disabled state.

The following directives open various Editor insert dialogs.

DirectiveAction
kendoEditorInsertImageButtonOpen image options dialog
kendoEditorCreateLinkButtonOpen link options dialog
kendoEditorInsertFileButtonOpen file options dialog
kendoEditorViewSourceButtonOpen view source dialog

Dialogs

The following commands are executed when the corresponding Dialog action is confirmed.

ActionAssociated Command
Insert imageinsertImage
Create linkcreateLink
Insert fileinsertFile
Update the sourcesetHTML

Each directive automatically defines the options of the drop-down list and sets its value.

DirectiveAssociated Command
kendoEditorFontFamilyfontFamily (accepts FontFamilyItem parameter)
kendoEditorFontSizefontSize (accepts FontSizeItem parameter)
kendoEditorFormatformat (accepts FormatItem parameter)

All of these tools allow providing a customized options collection for their respective styling setting.

For example, the font size tool can be used with all valid font-size units, e.g. px, rem, etc. Its data option takes a collection of FontSizeItem objects that constitute the custom font-sizes.

Example
View Source
Loading ...

ColorPickers

Each directive automatically defines the icon and the target of the operation over the color or background-color CSS properties.

The supported commands associate a kendo-toolbar-colorpicker component that changes the foreground and background color of the current selection.

DirectiveAssociated Command
kendoEditorForeColorforeColor
kendoEditorBackColorbackColor

Applying Commands to Words

By default, tools which apply text modifiers are affecting the current selection only (as in Google Docs). Those are the commands associated with:

  • Typographical emphases—bold, italic, underline, strikethrough, superscript, subscript
  • Fore and Background color—foreColor and backColor
  • Font size and family—fontSize and fontFamily
  • Link creation—createLink

To apply the respective tool command to the whole word the cursor is in, when no selection is present (as in MS Word), set the applyToWord option to true.

If there is an applied selection, the command will only affect that section, instead of the whole word.

The following example demonstrates how to apply text modifying commands to the whole word the cursor is in.

Example
View Source
Loading ...

Customizing Word Delimiters

The applyToWord property also accepts an ApplyToWordOptions configuration object, which enables you to configure the following options:

  • before—Regular expression of consequtive characters which will delimit the start of a word, when applying a command. The default value is /[^ !,?.\[\]{}()]+$/i
  • after—Regular expression of consequtive characters which will delimit the end of a word, when applying a command. The default value is /^[^ !,?.\[\]{}()]+/i

The default word delimiters are white-space and the following characters ! , ? . [ ] { } ( )

The following example demonstrates how to specify custom word delimiters via regular expressions. For the purposes of the demo, only a line terminator will be considered a delimiter.

Example
View Source
Loading ...

Custom Tools

Depending on the requirements of your project, the Editor enables you to create and implement your own custom tools.

Adding Custom UI Elements to the Toolbar

To add custom content such as a title, label, dropdown list, input field, or other application-specific control, create an Angular component for the custom content. To use the component as an Editor toolbar tool:

  1. Extend the ToolBarToolComponent class and register the component as a ToolBarToolComponent provider.

    ts
    @Component({
        providers: [{ provide: ToolBarToolComponent, useExisting: forwardRef(() => CustomToolComponent) }]
    })
    export class CustomToolComponent extends ToolBarToolComponent {}
  2. Define the custom content in an <ng-template #toolbarTemplate> and expose the template through a @ViewChild field named toolbarTemplate.

    html
    <ng-template #toolbarTemplate>
        <kendo-dropdownlist [data]="documentTypes"></kendo-dropdownlist>
    </ng-template>
  3. Add the custom component inside the Editor kendo-toolbar element.

    html
    <kendo-editor>
        <kendo-toolbar>
            <custom-tool></custom-tool>
            <kendo-toolbar-button kendoEditorBoldButton></kendo-toolbar-button>
        </kendo-toolbar>
    </kendo-editor>

To configure overflow behavior and keyboard navigation for custom tools, see Custom Control Types in the Kendo UI ToolBar for Angular.

The following example demonstrates a document-editing workflow with a custom document type selector before the formatting tools and custom Draft and Publish controls aligned to the right of the toolbar.

Example
View Source
Loading ...

Associating Command Tools with Directives

You can also create custom directives that control the look and behavior of the toolbar tools.

The following example demonstrates how to create a directive that sets the icon of the button and executes an Editor command on click. You can obtain a reference to the Editor through the Angular Host decorator.

Example
View Source
Loading ...

Associating Toolbar Tools with Editor Commands

To execute commands that modify the text of the Editor, you can use the exec method of the component. The method accepts two arguments—command name and attributes (optional).

html
<kendo-toolbar-button
    ext="Insert HTML"
    (click)="editor.exec('setHTML', '<p>HTML content</p>')"
></kendo-toolbar-button>

The following example demonstrates how to call a bold command when the user clicks a toolbar button.

Example
View Source
Loading ...

The table below lists all commands the exec method supports.

CommandDescriptionUsage
alignLeftAligns the text to the left.editor.exec('alignLeft');
alignCenterAligns the text to the center.editor.exec('alignCenter');
alignRightAligns the text to the right.editor.exec('alignRight');
alignJustifyJustifies the text.editor.exec('alignJustify');
addColumnBeforeAdds a column before the current position.editor.exec('addColumnBefore');
addColumnAfterAdds a column after the current position.editor.exec('addColumnAfter');
addRowBeforeAdds a row before the current position.editor.exec('addRowBefore');
addRowAfterAdds a row after the current position.editor.exec('addRowAfter');
boldToggles the bold styling.editor.exec('bold');
backColorSets the background color.editor.exec('backColor', { value: '#ffff00' });
blockquoteApplies a blockquote style.editor.exec('blockquote');
createLinkCreates a hyperlink.editor.exec('createLink', { href: 'www.progress.com', title: 'Progress', target: 'window' });
cleanFormatRemoves formatting.editor.exec('cleanFormat');
cleanFormattingCleans formatting.editor.exec('cleanFormatting');
deleteRowDeletes the current row.editor.exec('deleteRow');
deleteColumnDeletes the current column.editor.exec('deleteColumn');
deleteTableDeletes the table.editor.exec('deleteTable');
formatChanges the format of a text block.editor.exec('format', { tag: 'h2' });
fontFamilyChanges the font family.editor.exec('fontFamily', { value: 'Arial' });
fontSizeChanges the font size of the selected text.editor.exec('fontSize', 24);
foreColorSets the text color.editor.exec('foreColor', { value: '#ff0000' });
italicToggles the italic styling.editor.exec('italic');
insertFileInserts a file.editor.exec('insertFile', { href: 'fileLink', title: 'My file', target: 'window' });
insertImageInserts an image.editor.exec('insertImage', { src: 'imageLink', title: 'Progress', target: 'window' });
insertOrderedListInserts an ordered list.editor.exec('insertOrderedList');
insertUnorderedListInserts an bullet list.editor.exec('insertUnorderedList');
insertTextInserts a text at a given position. If no position is specified, the text will be inserted after the cursor.editor.exec('insertText', { text: 'Hello World!', from: 0, to: 0 });
indentIndents the text.editor.exec('indent');
insertTableCreates and inserts a table with the specified number of rows and columns. Numbers are zero based.editor.exec('insertTable', { rows: 3, cols: 5 });
mergeCellsMerges selected cells.editor.exec('mergeCells');
outdentOutdents the text.editor.exec('outdent');
redoRedoes the last undone action.editor.exec('redo');
strikethroughToggles the strikethrough styling.editor.exec('strikethrough');
subscriptToggles subscript styling.editor.exec('subscript');
superscriptToggles superscript styling.editor.exec('superscript');
splitCellSplits the current cell.editor.exec('splitCell');
selectAllSelects all content.editor.exec('selectAll');
setHTMLChanges the content of the Editor.editor.exec('setHTML', '<p>HTML content</p>');
underlineToggles the underline styling.editor.exec('underline');
undoUndoes the last action.editor.exec('undo');
unlinkRemoves the hyperlink.editor.exec('unlink');